package advertising

import (
	"applet/app/svc/advertising"
	"github.com/gin-gonic/gin"
)

// GetBasic
// @Summary      广告管理-基础设置-信息
// @Tags         广告管理
// @Description  广告管理-基础设置-信息
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Success      200   {object}  md.AdvertisingBaseResp			"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/advertising/getBasic [get]
func GetBasic(c *gin.Context) {
	advertising.GetBasic(c)
}

// SetBasic
// @Summary      广告管理-基础设置-信息保存
// @Tags         广告管理
// @Description  广告管理-基础设置-信息保存
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Param        req 	body      md.AdvertisingBase          true   "(分页信息必填)"
// @Success      200   {string}  		"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/advertising/setBasic [post]
func SetBasic(c *gin.Context) {
	advertising.SetBasic(c)
}

// GetPlayletBasic
// @Summary      广告管理-短剧设置-信息
// @Tags         广告管理
// @Description  广告管理-短剧设置-信息
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Success      200   {object}  md.PlayletIncentiveBaseData			"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/advertising/getPlayletBasic [get]
func GetPlayletBasic(c *gin.Context) {
	advertising.GetPlayletBasic(c)
}

// SetPlayletBasic
// @Summary      广告管理-短剧设置-信息保存
// @Tags         广告管理
// @Description  广告管理-短剧设置-信息保存
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Param        req 	body      md.PlayletIncentiveBaseData          true   "(分页信息必填)"
// @Success      200   {string}  		"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/advertising/setPlayletBasic [post]
func SetPlayletBasic(c *gin.Context) {
	advertising.SetPlayletBasic(c)
}
