package advertising

import (
	"applet/app/svc/advertising"
	"github.com/gin-gonic/gin"
)

// List
// @Summary      广告管理-广告列表
// @Tags         广告管理
// @Description  广告管理-广告列表
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Param        req 	body      md.AdvertisingListReq          true   "(分页信息必填)"
// @Success      200   {object}  md.AdvertisingListResp			"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/advertising/list [post]
func List(c *gin.Context) {
	advertising.List(c)
}

// VisitList
// @Summary      广告管理-回调列表
// @Tags         广告管理
// @Description  广告管理-回调列表
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Param        req 	body      md.AdvertisingVisitListReq          true   "(分页信息必填)"
// @Success      200   {object}  md.AdvertisingVisitListResp			"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/advertising/visit/list [post]
func VisitList(c *gin.Context) {
	advertising.VisitList(c)
}

// Del
// @Summary     广告管理-广告列表-删除
// @Tags         广告管理
// @Description   广告管理-广告列表-删除
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Param        req 	body      md.AdvertisingDelReq          true   "(分页信息必填)"
// @Success      200   {string}		"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/advertising/del [post]
func Del(c *gin.Context) {
	advertising.Del(c)
}

// Save
// @Summary     广告管理-广告列表-保存
// @Tags         广告管理
// @Description   广告管理-广告列表-保存
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Param        req 	body      md.AdvertisingSaveReq          true   "(分页信息必填)"
// @Success      200   {string}		"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/advertising/save [post]
func Save(c *gin.Context) {
	advertising.Save(c)
}
