package member_center

import (
	svc "applet/app/svc/member_center"
	"github.com/gin-gonic/gin"
)

// CertificateList
// @Summary      会员中心-证书管理
// @Tags         会员中心
// @Description  会员中心-证书管理
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Param        req 	body      md.CertificateListReq          true   "(分页信息必填)"
// @Success      200   {object}  md.CertificateListResp			"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/memberCenter/certificate/list [post]
func CertificateList(c *gin.Context) {
	svc.CertificateList(c)
}

// CertificateDel
// @Summary     会员中心-证书管理-删除
// @Tags         会员中心
// @Description   会员中心-证书管理-删除
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Param        req 	body      md.CertificateDelReq          true   "(分页信息必填)"
// @Success      200   {string}		"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/memberCenter/certificate/del [post]
func CertificateDel(c *gin.Context) {
	svc.CertificateDel(c)
}

// CertificateSave
// @Summary     会员中心-证书管理-保存
// @Tags         会员中心
// @Description   会员中心-证书管理-保存
// @Accept       json
// @Produce      json
// @param Authorization header string true "验证参数Bearer和token空格拼接"
// @Param        req 	body      md.CertificateSave          true   "(分页信息必填)"
// @Success      200   {string}		"具体数据"
// @Failure      400   {object}   md.Response              	"具体错误"
// @Router       /api/memberCenter/certificate/save [post]
func CertificateSave(c *gin.Context) {
	svc.CertificateSave(c)
}
