package md

import "code.fnuoos.com/EggPlanet/egg_models.git/src/model"

type Paginate struct {
	Limit int   `json:"limit"` // 每页大小
	Page  int   `json:"page"`  // 页数
	Total int64 `json:"total"` // 总数据量
}

type GetBlackListNode struct {
	BlackListId   int    `json:"black_list_id"`  // 黑名单 id
	Memo          string `json:"memo"`           // 备注
	Uid           int64  `json:"uid"`            // 用户 id
	UserNickname  string `json:"user_nickname"`  // 用户名称
	AdminId       int    `json:"admin_id"`       // 管理员 id
	AdminNickname string `json:"admin_nickname"` // 管理员名称
	CreatedAt     string `json:"created_at"`     // 添加时间
}

type GetBlackListResp struct {
	List     []GetBlackListNode `json:"list"`     // 具体信息
	Paginate Paginate           `json:"paginate"` // 分页信息
}

type AddBlackListReq struct {
	Uid  int64  `json:"uid,required"` // 用户 id
	Memo string `json:"memo"`         // 备注
}

type DeleteBlackListReq struct {
	BlackListId int `json:"id,required"` // 黑名单 id
}

type BlackListInfo struct {
	model.EggFriendCircleUserBlackList `xorm:"extends"`
	UserNickname                       string `xorm:"user.nickname"`
}
