package md

type PageCustomerServiceReq struct {
	Page     int    `json:"page"`
	PageSize int    `json:"page_size"`
	State    int    `json:"state"` //状态
	Memo     string `json:"memo" example:"备注"`
	Phone    string `json:"phone"` // 手机号
}

type PageCustomerServiceResp struct {
	Page     int   `json:"page"`
	PageSize int   `json:"page_size"`
	Total    int64 `json:"total"`
	List     []struct {
		Id           int64  `json:"id"` //记录id
		Phone        string `json:"phone" example:"手机号"`
		Nickname     string `json:"nickname" example:"昵称"`
		Weight       int32  `json:"weight"`                     // 权重
		State        int32  `json:"state"`                      // 状态(1:正常 2:冻结)
		HaasUserNums int    `json:"has_user_nums"`              // 拥有用户数量
		Memo         string `json:"memo" example:"备注"`          // 备注
		CreateTime   string `json:"create_time" example:"创建时间"` // 创建时间
		UpdateTime   string `json:"update_time" example:"更新时间"` // 更新时间
	} `json:"list"`
}

type AddCustomerServiceReq struct {
	Phone  string `json:"phone" example:"手机号"`
	Memo   string `json:"memo" example:"备注"` // 备注
	Weight int32  `json:"weight"`            // 权重
}

type SetCustomerServiceStateReq struct {
	Id    int   `json:"id"`    // 拥有用户数量
	State int32 `json:"state"` // 状态
}

type UpdateCustomerServiceMemoReq struct {
	Id   int    `json:"id"`                // 拥有用户数量
	Memo string `json:"memo" example:"备注"` // 备注
}
