package md

type SetVideoRewardReq struct {
	UnitPrice string `json:"unit_price,required"` // 单价
	Ecpm      string `json:"ecpm,required"`       // 当前 Ecpm 值
}

type GetVideoRewardResp struct {
	UnitPrice string `json:"unit_price"` // 单价
	Ecpm      string `json:"ecpm"`       // 当前 Ecpm 值
}

type ListPlatformRevenueReq struct {
	Kind    int    `json:"kind"` // 数据类型
	StartAt string `json:"start_at" example:"开始时间"`
	EndAt   string `json:"end_at" example:"结束时间"`
	Page    int    `json:"page,required"`   // 页数
	Limit   int    `json:"limit,required" ` // 每页大小
}

type PlatformRevenueDataNode struct {
	SystemID      int    `json:"system_id"`
	Kind          int    `json:"kind" `           // 种类(1:开屏广告 2:banner 广告 3:信息流广告 4：插屏广告)
	TotalAmount   string `json:"total_amount" `   // 金额
	BalanceAmount string `json:"balance_amount" ` // 余额
	Hours         int    `json:"hours" `          // 时长
	BalanceTimes  int    `json:"balance_times" `  // 剩余执行次数
	Memo          string `json:"memo" `           // 备注
	CreateAt      string `json:"create_at" `      // 创建时间
}

type ListPlatformRevenueResp struct {
	KindList []map[string]interface{}  `json:"kind_list"` // 类型列表
	Paginate Paginate                  `json:"paginate"`  // 分页数据
	List     []PlatformRevenueDataNode `json:"list"`      // 数据列表
}

type AddPlatformRevenueReq struct {
	Kind        int    `json:"kind,required"`         // 种类(1:开屏广告 2:banner 广告 3:信息流广告 4：插屏广告)
	TotalAmount string `json:"total_amount,required"` // 金额
	Hours       int    `json:"hours,required"`        // 时长(小时)
	Memo        string `json:"memo" example:"备注"`
	Frequency   int    `json:"frequency,required"` // 频率(分钟)
}
