package md

var AdvertisingPlatform = []map[string]string{
	{"name": "穿山甲", "value": "chuanshanjia"},
	{"name": "优量汇", "value": "youlianghui"},
}
var AdvertisingType = []map[string]string{
	{"name": "APP开屏(开屏广告)", "value": "open_advertisement"},
	{"name": "(新版弃用)蛋蛋主题砸蛋(激励视频)", "value": "incentive_eggSmash"},
	{"name": "蛋蛋主题砸蛋一(激励视频)", "value": "incentive_eggSmash_1"},
	{"name": "蛋蛋主题砸蛋二(激励视频)", "value": "incentive_eggSmash_2"},
	{"name": "蛋蛋主题砸蛋三(激励视频)", "value": "incentive_eggSmash_3"},
	{"name": "蛋蛋主题砸蛋四(激励视频)", "value": "incentive_eggSmash_4"},
	{"name": "蛋蛋主题砸蛋五(激励视频)", "value": "incentive_eggSmash_5"},
	{"name": "蛋蛋主题砸蛋六(激励视频)", "value": "incentive_eggSmash_6"},

	{"name": "蛋蛋主题签到(激励视频)", "value": "incentive_eggSign"},
	{"name": "提现(激励视频)", "value": "incentive_withdraw"},
	{"name": "积分兑换(插屏)", "value": "interstitial_integralExchange"},
	{"name": "动态IM(信息流)", "value": "information_im"},
	{"name": "蛋蛋主题底部(信息流)", "value": "information_eggTheme"},
	{"name": "会员中心底部(信息流)", "value": "information_member"},
	{"name": "首页介绍底部(信息流)", "value": "information_index"},
	{"name": "提现底部(信息流)", "value": "information_withdraw"},
}

type AdvertisingBase struct {
	AndroidAdIsOpen     string `json:"android_ad_is_open" example:"安卓广告是否开启(1:开启 0:不开启)"`
	IosAdIsOpen         string `json:"ios_ad_is_open" example:"ios广告是否开启(1:开启 0:不开启)"`
	AndroidOpenAdIsOpen string `json:"android_open_ad_is_open" example:"安卓开屏广告是否开启(1:开启 0:不开启)"`
	IosOpenAdIsOpen     string `json:"ios_open_ad_is_open" example:"ios开屏广告是否开启(1:开启 0:不开启)"`
	Voice               string `json:"voice" example:"领取奖励声音"`
	VoiceUrl            string `json:"voice_url"`
	Info                string `json:"info"  example:"广告商配置 {\"chuanshanjia\":{\"android_app_key\":\"\"}}"`
}
type AdvertisingBaseResp struct {
	SelectData      []map[string]string `json:"select_data"`
	AdvertisingBase AdvertisingBase     `json:"advertising_base"`
}
type AdvertisingListReq struct {
	Page  string `json:"page"`
	Limit string `json:"limit"`
	Name  string `json:"name"`
	Kind  string `json:"kind"`
}

type AdvertisingListResp struct {
	AdvData    []map[string]string `json:"adv_data"`
	SelectData []map[string]string `json:"select_data"`
	Total      int64               `json:"total"`
	List       []AdvertisingList   `json:"list"`
}
type AdvertisingList struct {
	Id           string `json:"id" `
	Name         string `json:"name" example:"名称"`
	Kind         string `json:"kind" example:"广告类型(1:开屏广告 2:插屏广告 3:激励视频 4:信息流广告  5:全屏视频)"`
	Info         string `json:"info" example:"广告位配置 {\"chuanshanjia\":{\"android_ad_id\":[{\"id\":\"\",\"key\":\"\"}],\"ios_ad_id\":[{\"id\":\"\",\"key\":\"\"}}}"`
	CountingDown string `json:"counting_down" example:"倒计时 单位秒"`
}
type AdvertisingVisitListReq struct {
	Page      string `json:"page"`
	Limit     string `json:"limit"`
	Uid       string `json:"uid"`
	Phone     string `json:"phone"`
	Amount    string `json:"amount" example:"ecpm "`
	StartTime string `json:"start_time"`
	EndTime   string `json:"end_time"`
	Platform  string `json:"platform" example:"广告平台 "`
	Type      string `json:"type"  example:"广告类型 "`
}

type AdvertisingVisitListResp struct {
	PlatformData []map[string]string    `json:"platform_data"`
	TypeData     []map[string]string    `json:"type_data"`
	Total        int64                  `json:"total"`
	List         []AdvertisingVisitList `json:"list"`
}
type AdvertisingVisitList struct {
	Id            string `json:"id" `
	Uid           string `json:"uid" example:"用户id"`
	Phone         string `json:"phone" example:"手机号"`
	Ecpm          string `json:"ecpm" example:"ecpm"`
	CustomEcpm    string `json:"custom_ecpm" example:"ecpm"`
	Integral      string `json:"integral" example:"活跃值"`
	Platform      string `json:"platform" example:"广告平台"`
	PhonePlatform string `json:"phone_platform" example:"手机平台"`
	Type          string `json:"type" example:"广告位置"`
	Time          string `json:"time" example:"时间"`
}
type AdvertisingDelReq struct {
	Id []string `json:"id"`
}
type AdvertisingSaveReq struct {
	Id           string `json:"id"`
	Name         string `json:"name" example:"名称"`
	Kind         string `json:"kind" example:"广告类型(1:开屏广告 2:插屏广告 3:激励视频 4:信息流广告  5:全屏视频)"`
	Info         string `json:"info" example:"广告位配置 {\"chuanshanjia\":{\"android_ad_id\":[{\"id\":\"\",\"key\":\"\"}],\"ios_ad_id\":[{\"id\":\"\",\"key\":\"\"}}}"`
	CountingDown string `json:"counting_down" example:"倒计时 单位秒"`
}
type AdvertisingLimit struct {
	Minute         string `json:"minute" example:"分钟"`
	ImeiNum        string `json:"imei_num" example:"设备数量"`
	Tip            string `json:"tip" example:"限制提示"`
	PublicImg      string `json:"public_img" example:"公共弹窗图"`
	PublicImgUrl   string `json:"public_img_url" example:"公共弹窗图"`
	PublicStr      string `json:"public_str" example:"公共弹窗文字"`
	WithdrawImg    string `json:"withdraw_img" example:"提现弹窗图"`
	WithdrawImgUrl string `json:"withdraw_img_url" example:"提现弹窗图"`
	WithdrawStr    string `json:"withdraw_str" example:"提现弹窗文字"`
}

type AdvertisingFunctionListReq struct {
	Page  string `json:"page"`
	Limit string `json:"limit"`
}
type AdvertisingFunctionListResp struct {
	SelectData []map[string]string       `json:"select_data"`
	AdvData    []map[string]string       `json:"adv_data"`
	Total      int64                     `json:"total"`
	List       []AdvertisingFunctionList `json:"list"`
}
type AdvertisingFunctionList struct {
	Id   string `json:"id" `
	Type string `json:"type" example:"类型"`
	AdId string `json:"ad_id" example:"广告id"`
}
