package md

type CloudBundleReq struct {
	Page  string `json:"page,required"`  // 页数
	Limit string `json:"limit,required"` // 每页大小
}
type CloudBundleResp struct {
	Total         int64                   `json:"total"`
	List          []CloudBundleList       `json:"list"`
	LastBit       string                  `json:"last_bit"`
	LastPlatform  []string                `json:"last_platform"`
	LastIsCombine string                  `json:"last_is_combine"`
	LastAndroid   string                  `json:"last_android"`
	ListIos       string                  `json:"list_ios"`
	SelectData    []CloudBundleVersionMap `json:"select_data"`
}
type CloudBundleList struct {
	Id         string `json:"id"`
	BuildId    string `json:"build_id"`
	Version    string `json:"version"`
	Os         string `json:"os"`
	State      string `json:"state"`
	Memo       string `json:"memo"`
	Src        string `json:"src"`
	Bit        string `json:"bit"`
	ApplyAt    string `json:"apply_at"`
	FinishAt   string `json:"finish_at"`
	IsCombine  string `json:"is_combine"`
	IsAuditing string `json:"is_auditing"`
	Platform   string `json:"platform"`
}
type CloudBundleBuildReq struct {
	Memo      string   `json:"memo"`
	Version   string   `json:"version"`
	Os        string   `json:"os"`
	Bit       []string `json:"bit"`
	Platform  []string `json:"platform"`
	IsCombine string   `json:"isCombine"`
}
type CloudBundleBase struct {
	AndroidLogo   string `json:"android_logo"`
	IosLogo       string `json:"ios_logo"`
	Build10802280 string `json:"build_1080_2280"`
	Build11252436 string `json:"build_1125_2436"`
	Build12422208 string `json:"build_1242_2208"`
	Build6401136  string `json:"build_640_1136"`
	Build640960   string `json:"build_640_960"`
	Build7201280  string `json:"build_720_1280"`
	Build7501334  string `json:"build_750_1334"`
}
type CloudBundleBaseResp struct {
	AndroidLogo  string            `json:"android_logo"`
	IosLogo      string            `json:"ios_logo"`
	LaunchScreen map[string]string `json:"launch_screen"`
}

type CloudBundleUpdateStateReq struct {
	Id          string `json:"id"`
	State       string `json:"state"`
	Src         string `json:"src"`
	BuildId     string `json:"build_id"`
	BuildNumber string `json:"build_number"`
	ErrorMsg    string `json:"error_msg"`
}
type CloudBundleImgResp struct {
	AndroidLogo      string  `json:"android_logo"`
	AndroidLogoUrl   string  `json:"android_logo_url"`
	IosLogo          string  `json:"ios_logo"`
	IosLogoUrl       string  `json:"ios_logo_url"`
	Guide            []Guide `json:"guide"`
	Build10802280    string  `json:"build_1080_2280"`
	Build11252436    string  `json:"build_1125_2436"`
	Build12422208    string  `json:"build_1242_2208"`
	Build6401136     string  `json:"build_640_1136"`
	Build640960      string  `json:"build_640_960"`
	Build7201280     string  `json:"build_720_1280"`
	Build7501334     string  `json:"build_750_1334"`
	Build10802280Url string  `json:"build_1080_2280_url"`
	Build11252436Url string  `json:"build_1125_2436_url"`
	Build12422208Url string  `json:"build_1242_2208_url"`
	Build6401136Url  string  `json:"build_640_1136_url"`
	Build640960Url   string  `json:"build_640_960_url"`
	Build7201280Url  string  `json:"build_720_1280_url"`
	Build7501334Url  string  `json:"build_750_1334_url"`
}

type Guide struct {
	BgImage         string `json:"bg_image"`
	BgImageUrl      string `json:"bg_image_url"`
	ContentImage    string `json:"content_image"`
	ContentImageUrl string `json:"content_image_url"`
}
type AuditClearReq struct {
	Os string `json:"os" example:"1-安卓 2-ios"`
}
type CloudBundleDelReq struct {
	Ids []string `json:"ids"`
}

type CloudBundleVersion struct {
	Type     string `json:"type"`
	Img      string `json:"img"`
	ImgUrl   string `json:"img_url"`
	Name     string `json:"name"`
	Version  string `json:"version"`
	Url      string `json:"url"`
	DownType string `json:"down_type"`
	OutUrl   string `json:"out_url"`
	Content  string `json:"content"`
	IsMust   string `json:"is_must"`
}
type CloudBundleVersionMap struct {
	Type string `json:"type"`
	Name string `json:"name"`
	Img  string `json:"img"`
}
type CloudBundleVersionResp struct {
	Version []CloudBundleVersion `json:"version"`
}
