package md

type WebsiteInfoResp struct {
	SeoTitle       string `json:"seo_title" example:"seo"`
	SeoLogo        string `json:"seo_logo"`
	WebLogo        string `json:"web_logo"`
	AndroidDownUrl string `json:"android_down_url"`
	IosDownUrl     string `json:"ios_down_url"`
}
type GetModuleSettingResp struct {
	ModName        string      `json:"mod_name"`        // 模块名称
	Position       string      `json:"position"`        // 位置
	SkipIdentifier string      `json:"skip_identifier"` // 跳转标识
	Title          string      `json:"title"`           // 标题
	Subtitle       string      `json:"subtitle"`        // 副标题
	Data           interface{} `json:"data"`            // 内容
}
type CertificateReq struct {
	No string `json:"no" example:"DD123"`
}
type CertificateResp struct {
	No        string `json:"no" example:"编号"`
	Name      string `json:"name" example:"姓名"`
	StartTime string `json:"start_time" example:"开始时间"`
	EndTime   string `json:"end_time" example:"结束时间"`
	Logo      string `json:"logo"  example:"logo"`
	BgImg     string `json:"bg_img"  example:"背景图"`
	NameIcon  string `json:"name_icon"  example:"蛋蛋星球文字图"`
	Medal     string `json:"medal" example:"勋章"`
	Seal      string `json:"seal" example:"印章"`
}

var Certificate = CertificateResp{
	Logo:     "default_icon/certificate_logo.png",
	BgImg:    "default_icon/certificate_bg_img.jpg",
	NameIcon: "default_icon/certificate_name_icon.png",
	Medal:    "default_icon/certificate_medal.png",
	Seal:     "default_icon/certificate_seal.png",
}
