package svc

import (
	"applet/app/db"
	md "applet/app/md/friend_circle"
)

func GetBlackList(page, limit int, phone, nickname, uid string) ([]md.BlackListInfo, int64, error) {
	blackLists := make([]md.BlackListInfo, 0)
	session := db.Db.Table("egg_friend_circle_user_black_list").Alias("black").
		Join("LEFT OUTER", "user", "black.uid = user.id")
	if phone != "" {
		phone = "%" + phone + "%"
		session.Where("user.phone like ?", phone)
	}
	if nickname != "" {
		nickname = "%" + nickname + "%"
		session.Where("nickname like ?", nickname)
	}
	if uid != "" {
		uid = "%" + uid + "%"
		session.Where("uid like ?", uid)
	}
	total, err := session.Limit(limit, (page-1)*limit).FindAndCount(&blackLists)
	if err != nil {
		return nil, 0, err
	}
	return blackLists, total, nil
}
