package svc

import (
	"applet/app/db"
	"applet/app/utils"
	"applet/app/utils/logx"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/implement"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	"fmt"
	"github.com/gin-gonic/gin"
	"math/rand"
	"time"
	"unicode"
)

// 简单的recover
func Rev() {
	if err := recover(); err != nil {
		_ = logx.Error(err)
	}
}

func ReturnCode(l, types, num int) string {
	if num > 5 {
		return ""
	}
	//循环3次判断是否存在该邀请码
	var code string
	var (
		codes []string
	)
	for i := 0; i < 3; i++ {
		oneCode := GetRandomString(l, types)
		codes = append(codes, oneCode)
	}

	//判断是不是存在邀请码了
	userDb := implement.NewUserDb(db.Db)
	tmp, _ := userDb.UserFindByInviteCodes(codes...)
	//判断自定义是不是存在邀请码了
	customTmp, _ := userDb.UserFindByCustomInviteCodes(codes...)

	//循环生成的邀请码 判断tmp里有没有这个邀请码 如果邀请码没有就赋值 再判断是否存在 存在就清空
	repeat := []string{"46ZQP3", "YJ61CV", "FBBD6P", "K2ZK47", "S46ZQP", "8QZEN6", "X1K9JI", "RY2HUG", "FQJOF6", "3HFFVH", "ALRC49", "1I6DBA", "RT537I", "R8Z95Z", "ADT33R", "9Z5N3C", "AMLIB0", "4FJ2HM", "1P1186", "373V3E", "IGCL3W", "RY4N0T", "12B5VA", "G7BKRS", "NBQWY3", "5C9RGD", "0SQSS7", "OARC7F", "O9RQKR", "LV6SMZ", "RY929H", "2CGLA5", "6WG3W7", "2OCXXJ", "Z74D5E", "MZT1BE", "5KU4Z9", "JMY2OA", "TVO9LM", "MX4ORM", "AFQ60J", "B2LLUQ", "S66KH5", "CMO6XX", "9JNH3G", "I5KSZL", "V3QMWG", "NYOS6I", "SCCX47", "IE250I", "95LT56", "OSJ7VD", "UWW8JU", "GPQUP3", "9YJ0CI", "2JA8YT", "Z5MOM4", "B41PBO", "7QUTOH", "FN3N4F", "639NNI", "9GDNEZ", "6BLIIS", "MHKK2I", "W05VR0", "QNI24A", "6Z13ER", "SU8VQL", "H0JKDS", "P6X6XI", "EXQ8P1", "1NZJBI", "HJI1GT", "M6OLIZ", "66WS8X", "XXS04V", "VNR363", "FD9CRH", "40TCCD", "QNWZR1", "6EAD47", "1HK0KF", "AR3IY5", "F1B3GM", "Q479YA", "F7D198", "VD7FXV", "8I7WF4", "SUO254", "VTH32H", "SLHLA5", "7TFEFZ", "73L091", "3CEYZ2", "20ZIY5", "4Q6JIK", "P4K0NX", "M04OUK", "3KUZSH", "YZG4HN", "A5LE91", "CDJQO4", "5XTSKP", "3KOR4B", "S69MBU", "881EYC", "KDZB13", "K22C83", "M08M6A", "31OY42", "8FHO8O", "P7AE2M", "W6ADG4", "DMAGW9", "AV653E", "9NEFFX", "P8E8LX", "1PINC4", "1Y2A0B", "HD1BPN", "S3W9WB", "Q9I0XO", "75K0KL", "Y72G14", "KL8HAX", "JS41K1", "G4L34B", "RV8KBP", "VG2S5B", "V6ZP51", "S5DWD8", "J24KTU", "N7IFG8", "4Z94WX", "4TOK2G", "8COMEX", "OO2M08", "IQDA9G", "V1Y8HC", "UBE4KZ", "C6JVML", "89DHLX", "PIW413", "UAJ4KB", "SPEQB9", "7CJDW8", "E2Q8MW", "M1PDC3", "1C7QIR", "O122E4", "F735IK", "4GGZU3", "4CW5N8", "ISCC02", "7WB4ET", "7PQQK4", "FSKO12", "6VREUP", "Q21NUE", "KOK7GQ", "J2U1U9", "TJ3O19", "99SWY1", "46SO3B", "NO5HE5", "J2N5GU", "2ADNIW", "K014LU", "UDC2RY", "DSGQ3O", "579A6Z", "MG3H08", "WXZL8M", "MG8PG7", "1JKUF8", "ITP4WQ", "6FAOU3", "00GTZQ", "XYUYO4", "GS9YJ6", "KQ7UWT", "7981LY", "J7BGGU", "XMJEB9", "E58TS4", "IL82FA", "P3RR5Z", "5RYDW0", "GCU8OJ", "12YH73", "K8LF5L", "Z79K5R", "KHX1BY", "7K3YSL", "WM9OH5", "0DL3OH", "KKLQJ1", "XPROG1", "OB66GR", "7ZYCNE", "L6010Q", "9KNBJC", "H0A6Z2", "VC5X88", "MAZKT8", "FZTL3Q", "T58EF4", "G7A2PB", "K19Y5W", "39842R", "UIIX8U", "GY5D0Y", "3723U5", "5UZPDO", "74RTB0", "5J9ZQ3", "24S3YM", "UZ7CF8", "J8FYO6", "MF7AKW", "OMY3T6", "X0F7YO", "NCGTM2", "MZNPO3", "ROBSR6", "67CHNX", "Y1KTV2", "PKZ925", "429OSC", "WB8TRY", "7ZWUQ4", "F8HQGC", "5NG2HI", "RTRQ9W", "4EH1GI", "VSQB15", "34ZRJS", "ENO4TN", "MW0P2T", "IR298E", "3ZEH1K", "NRHKD4", "EVL5DO", "A17WRT", "1SGNB7", "28YJXV", "DQEQ8G", "X4ZI02", "E4VXT8", "J7AV62", "N3BNH8", "IVUX2P", "Y5KOXS", "SRT4X1", "FBY12A", "5HMYIR", "ONCKZ7", "0D84XJ", "BX9YZ2", "SIS6RC", "ZT7TFB", "TRPBB9", "V7QMAH"}
	for _, v := range codes {
		if utils.InArr(v, repeat) { //出问题的不给用了
			continue
		}
		if code != "" { //如果存在并且数据库没有就跳过
			continue
		}
		code = v
		for _, v1 := range *tmp {
			//如果存在就清空
			if v1.SystemInviteCode == v {
				code = ""
			}
		}
		for _, v1 := range *customTmp {
			//如果存在就清空
			if v1.CustomInviteCode == v {
				code = ""
			}
		}
	}
	//如果都没有就继续加一位继续查
	if code == "" {
		return ReturnCode(l+1, types, num+1)
	}
	return code
}

// 随机生成指定位数的大写字母和数字的组合
func GetRandomString(l, isLetter int) string {
	str := "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	if isLetter != 1 {
		str = "0123456789"
	}
	strs := []rune(str)
	result := make([]rune, l)
	for i := range result {
		result[i] = strs[rand.Intn(len(strs))]
	}
	if IsLetter(string(result)) && isLetter == 1 {
		return GetRandomString(l, isLetter)
	}
	return string(result)
}

func IsLetter(s string) bool {
	for _, r := range s {
		if !unicode.IsLetter(r) {
			return false
		}
	}
	return true
}

// RoutineInsertUserRelate is  协程 当关联上级用户时，需要查询当前用户的所有关联下级，并新增关联上级与当前用户下级关系
func RoutineInsertUserRelate(puid, uid int64, addlv int) {
	userRelateDb := implement.NewUserRelateDb(db.Db)
	defer Rev()
	urs, err := userRelateDb.UserRelatesByPuid(uid, 0, 0)
	if err != nil {
		logx.Warn(err)
	}
	// fmt.Println(*urs)
	for _, item := range *urs {
		_, err = userRelateDb.UserRelateInsert(
			&model.UserRelate{
				ParentUid:  puid,
				Uid:        item.Uid,
				Level:      item.Level + addlv,
				InviteTime: time.Now().Format("2006-01-02 15:04:05"),
			})
		if err != nil {
			continue
		}
		logx.Info(fmt.Sprintf("关联pid(%v) -> uid(%v) ,lv:%v", puid, item.Uid, item.Level+addlv))

	}
}

// RoutineMultiRelate is 多级关联
func RoutineMultiRelate(pid, uid int64, lv int) {
	userDb := implement.NewUserDb(db.Db)
	userRelateDb := implement.NewUserRelateDb(db.Db)
	defer Rev()
	for {
		if pid == 0 {
			break
		}
		m, err := userDb.GetUser(pid)
		if err != nil || m == nil {
			logx.Warn(err)
			break
		}
		if m.ParentUid == 0 {
			break
		}
		lv++
		ur := new(model.UserRelate)
		ur.ParentUid = m.ParentUid
		ur.Uid = uid
		ur.Level = lv
		ur.InviteTime = time.Now().Format("2006-01-02 15:04:05")
		_, err = userRelateDb.UserRelateInsert(ur)
		if err != nil {
			logx.Warn(err)
			break
		}
		// 还要关联当前的用户的所有下级,注意关联等级
		RoutineInsertUserRelate(m.ParentUid, uid, lv)
		// 下级关联上上级
		// 继续查询
		logx.Info(fmt.Sprintf("关联pid(%v) -> uid(%v),lv:%v", ur.ParentUid, ur.Uid, lv))
		logx.Info("继续查询")
		pid = m.ParentUid
	}
}

func UserImeiAdd(c *gin.Context, uid int64) {
	var tmp model.UserImei
	get, _ := db.Db.Where("uid=? and imei=? and ip=?", uid, c.GetHeader("imei"), utils.GetIP(c.Request)).Get(&tmp)
	if get == false {
		var data = model.UserImei{
			Uid:      int(uid),
			Imei:     c.GetHeader("imei"),
			CreateAt: time.Now(),
			UpdateAt: time.Now(),
			Ip:       utils.GetIP(c.Request),
		}
		db.Db.Insert(&data)
	} else {
		tmp.UpdateAt = time.Now()
		db.Db.Where("id=?", tmp.Id).Cols("update_at").Update(&tmp)
	}

	NewUserDb := implement.NewUserDb(db.Db)
	user, _ := NewUserDb.GetUser(uid)
	if user != nil {
		user.LastLoginAt = time.Now().Format("2006-01-02 15:04:05")
		user.LastLoginIp = utils.GetIP(c.Request)
		db.Db.Where("id=?", user.Id).Cols("last_login_at,last_login_ip").Update(user)
		UpdateUserTime(user.Id, "login")
	}
}
func UpdateUserTime(uid int64, types string) {
	count, _ := db.Db.Where("uid=?", uid).Count(&model.UserNoticeTime{})
	if count == 0 {
		tmp := &model.UserNoticeTime{Uid: int(uid)}
		if types == "login" {
			tmp.LoginTime = int(time.Now().Unix())
		} else {
			tmp.SignTime = int(time.Now().Unix())
		}
		db.Db.Insert(tmp)
	} else {
		tmp := &model.UserNoticeTime{}
		str := ""
		if types == "login" {
			str = "login_time"
			tmp.LoginTime = int(time.Now().Unix())
		} else {
			str = "sign_time"
			tmp.SignTime = int(time.Now().Unix())
		}
		db.Db.Where("uid=?", uid).Cols(str).Update(tmp)
	}
}
