package svc

import (
	"applet/app/db"
	md "applet/app/md/member_center"
	"applet/app/utils"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/implement"
)

func TagManagementGetList(page, limit string) ([]md.TagListNode, int64, error) {
	sql := "SElECT count(distinct uid) as total, tag_id FROM `user_tag_records` GROUP BY tag_id"
	results, err := db.QueryNativeString(db.Db, sql)
	if err != nil {
		return nil, 0, err
	}
	var countMap = map[int64]string{}
	for _, res := range results {
		countMap[utils.StrToInt64(res["tag_id"])] = res["total"]
	}

	tagDb := implement.NewUserTagDb(db.Db)
	tags, total, err := tagDb.UserTagAllByAscByPage(utils.StrToInt(page), utils.StrToInt(limit))
	if err != nil {
		return nil, 0, err
	}

	list := make([]md.TagListNode, len(*tags))
	for i, tag := range *tags {
		list[i].Name = tag.TagName
		list[i].Count = countMap[int64(tag.Id)]
		list[i].CreateAt = tag.CreateAt
		list[i].Memo = tag.Memo
		list[i].TagID = utils.IntToStr(tag.Id)
		list[i].IsPunish = tag.IsPunish
	}

	return list, total, nil
}
